diff --git a/test/integration/local_web_mode_test.rb b/test/integration/local_web_mode_test.rb
new file mode 100644
index 000000000..d6810f3bd
--- /dev/null
+++ b/test/integration/local_web_mode_test.rb
@@ -0,0 +1,114 @@
+require "test_helper"
+require "json"
+require "open3"
+require "tmpdir"
+require "yaml"
+
+# U6 (acceptance layer, CLI-level): exercise the first-class local web mode
+# through the REAL bin/hive in an isolated HIVE_HOME + HOME sandbox. The
+# full boxed e2e (web up + live daemon + TUI round-trip) is CI-gated in the
+# web suite; this proves the local-mode command surface end-to-end without a
+# live Rails server.
+class LocalWebModeTest < Minitest::Test
+  include HiveTestHelper
+
+  REPO_ROOT = File.expand_path("../..", __dir__)
+  HIVE_BIN = File.join(REPO_ROOT, "bin", "hive")
+
+  def with_isolated_hive_home(&block)
+    Dir.mktmpdir("hive-localweb") do |home|
+      env = ENV.to_h.merge("HIVE_HOME" => home, "HOME" => home)
+      block.call(home, env)
+    end
+  end
+
+  # Build a `bin/` shim dir and prepend it to PATH. The qmd flat is enough to
+  # prevent the Hive-owned qmd bootstrap from running a real (slow/hanging)
+  # `npm install` in the sandbox — with a qmd on PATH the probe reports it
+  # present and no bootstrap runs.
+  def with_qmd_shim(home, env)
+    bindir = File.join(home, ".shim-bin")
+    FileUtils.mkdir_p(bindir)
+    qmd = File.join(bindir, "qmd")
+    File.write(qmd, "#!/bin/sh\necho \"qmd 0.0.0-test\"\n")
+    FileUtils.chmod(0o755, qmd)
+    env["PATH"] = [ bindir, env["PATH"] ].join(File::PATH_SEPARATOR)
+  end
+
+  def test_web_status_json_emits_envelope_without_a_service
+    with_isolated_hive_home do |_home, env|
+      out, _err, status = Open3.capture3(env, "ruby", "-Ilib", HIVE_BIN, "web", "status", "--json")
+      doc = JSON.parse(out)
+      assert_equal "hive-web-status", doc["schema"]
+      assert_equal false, doc["running"], "no web service installed/running in a fresh sandbox"
+      assert_equal false, doc["service_installed"]
+      assert status.success?
+    end
+  end
+
+  def test_setup_json_runs_the_full_local_surface_in_an_isolated_home
+    with_isolated_hive_home do |home, env|
+      with_qmd_shim(home, env)
+      out, _err, status = Open3.capture3(
+        env, "ruby", "-Ilib", HIVE_BIN, "setup", "--json", "--non-interactive"
+      )
+      doc = JSON.parse(out)
+      assert_equal "hive-setup", doc["schema"]
+      names = doc["steps"].map { |s| s["name"] }
+      %w[backends dependencies daemon web health].each do |step|
+        assert_includes names, step, "setup must run the #{step} step"
+      end
+      # The isolated home has no web app dir, but the daemon + web units
+      # still get written to the sandbox HOME.
+      assert File.exist?(File.join(home, ".config/systemd/user/hive-daemon.service")),
+             "setup must ensure the daemon unit in the sandbox HOME"
+      assert File.exist?(File.join(home, ".config/systemd/user/hive-web.service")),
+             "setup must ensure the web unit in the sandbox HOME"
+      # A fresh sandbox may be missing external agent CLIs → fix_required.
+      assert_includes [ 0, 65 ], status.exitstatus,
+                      "setup exits 0 (all deps found) or 65 (fix required); got #{status.exitstatus}"
+    end
+  end
+
+  # U6 acceptance: `hive setup` must ENROLL the current repo (not just hint)
+  # and write daemon + web units pointing at the SAME binary the CLI resolves
+  # (Hive::InvokedBinary.path). Run inside a real git repo so enrollment has a
+  # project to register.
+  def test_setup_enrolls_repo_and_writes_same_binary_units
+    with_tmp_git_repo do |repo|
+      with_isolated_hive_home do |home, env|
+        with_qmd_shim(home, env)
+        out, _err, status = Open3.capture3(
+          env, "ruby", "-Ilib", HIVE_BIN, "setup", "--json", "--non-interactive",
+          chdir: repo
+        )
+        doc = JSON.parse(out)
+        assert_equal "hive-setup", doc["schema"]
+
+        # Repo enrollment: the one-shot setup must register the repo, not
+        # merely print `hive init <root>`.
+        config = YAML.safe_load_file(File.join(home, "config.yml"))
+        registered = config.fetch("registered_projects", [])
+        assert registered.any? { |p| File.expand_path(p["path"]) == File.expand_path(repo) },
+               "hive setup must enroll the current repo in the registry"
+        enroll_step = doc.fetch("steps").find { |s| s["name"] == "enroll" }
+        assert_equal "ok", enroll_step["status"],
+                     "enroll step must report ok after registering the repo"
+
+        # Same-binary guarantee: both units' ExecStart must point at the
+        # exact binary the CLI resolves.
+        daemon_unit = File.join(home, ".config/systemd/user/hive-daemon.service")
+        assert File.exist?(daemon_unit), "setup must write the daemon unit"
+        assert_includes File.read(daemon_unit), "ExecStart=#{HIVE_BIN} daemon start",
+                       "daemon unit must point at the same binary as the CLI"
+        web_unit = File.join(home, ".config/systemd/user/hive-web.service")
+        assert File.exist?(web_unit), "setup must write the web unit"
+        assert_includes File.read(web_unit), "ExecStart=#{HIVE_BIN} web run",
+                       "web unit must point at the same binary as the CLI"
+
+        assert_includes [ 0, 65 ], status.exitstatus,
+                        "setup exits 0 (all deps found) or 65 (fix required); got #{status.exitstatus}"
+      end
+    end
+  end
+end
diff --git a/test/unit/cli_test.rb b/test/unit/cli_test.rb
index dafa1c291..a096d8aff 100644
--- a/test/unit/cli_test.rb
+++ b/test/unit/cli_test.rb
@@ -519,7 +519,10 @@ class HiveCliTest < Minitest::Test
     require "hive/commands/web"
     captured = []
     recorder = Class.new do
-      define_method(:initialize) { |bind:, port:| captured << { bind: bind, port: port } }
+      define_method(:initialize) do |subcommand = nil, bind: nil, port: nil, json: false,
+                                              force: false, allow_non_loopback: false|
+        captured << { subcommand: subcommand, bind: bind, port: port }
+      end
       define_method(:call) { captured << :called }
     end
 
@@ -533,8 +536,10 @@ class HiveCliTest < Minitest::Test
       Hive::Commands.const_set(:Web, original)
     end
 
-    assert_equal({ bind: "0.0.0.0", port: 9123 }, captured.first,
-                 "the --bind/--port flags must reach the web command")
+    assert_equal "run", captured.first[:subcommand],
+                 "hive web with no SUBCOMMAND must route to the foreground `run`"
+    assert_equal "0.0.0.0", captured.first[:bind], "--bind must reach the web command"
+    assert_equal 9123, captured.first[:port], "--port must reach the web command"
     assert_equal :called, captured.last, "hive web must invoke the web command's #call"
   end
 
diff --git a/test/unit/commands/daemon/drift_test.rb b/test/unit/commands/daemon/drift_test.rb
new file mode 100644
index 000000000..00edd9ef9
--- /dev/null
+++ b/test/unit/commands/daemon/drift_test.rb
@@ -0,0 +1,123 @@
+require "test_helper"
+require "hive/daemon/drift"
+require "hive/invoked_binary"
+
+class DaemonDriftTest < Minitest::Test
+  include HiveTestHelper
+
+  class FakeRunner
+    attr_reader :calls
+
+    def initialize(version: Hive::VERSION, ps_out: nil)
+      @version = version
+      @ps_out = ps_out
+      @calls = []
+    end
+
+    def call(argv)
+      @calls << argv
+      case argv[0]
+      when "ps"
+        { success: true, out: @ps_out.to_s + "\n" }
+      else # version probe
+        { success: true, out: "hive #{@version}\n" }
+      end
+    end
+  end
+
+  def with_fake_hive_binary(path)
+    old = Hive::InvokedBinary.method(:path)
+    Hive::InvokedBinary.define_singleton_method(:path) { path }
+    yield
+  ensure
+    Hive::InvokedBinary.define_singleton_method(:path, old)
+  end
+
+  def test_matching_binary_and_version_is_not_drifted
+    with_fake_hive_binary("/usr/local/bin/hive") do
+      drift = Hive::Daemon::Drift.new(pid: 4242, runner: FakeRunner.new(version: Hive::VERSION))
+      drift.define_singleton_method(:resolve_binary) { "/usr/local/bin/hive" }
+      result = drift.resolve
+      assert_equal true, result["verified"]
+      assert_equal false, result["drifted"]
+      assert_equal "ok", result["status"]
+      assert_equal "/usr/local/bin/hive", result["binary"]
+      assert_equal Hive::VERSION, result["version"]
+    end
+  end
+
+  def test_stale_binary_is_drifted
+    with_fake_hive_binary("/usr/local/bin/hive") do
+      drift = Hive::Daemon::Drift.new(pid: 4242, runner: FakeRunner.new(version: Hive::VERSION))
+      drift.define_singleton_method(:resolve_binary) { "/usr/bin/hive" }
+      result = drift.resolve
+      assert_equal true, result["verified"]
+      assert_equal true, result["drifted"],
+                   "a daemon running /usr/bin/hive while the CLI is the wrapper must be flagged drifted"
+      assert_equal "drifted", result["status"]
+    end
+  end
+
+  def test_stale_version_is_drifted
+    with_fake_hive_binary("/usr/local/bin/hive") do
+      drift = Hive::Daemon::Drift.new(pid: 4242, runner: FakeRunner.new(version: "0.1.0"))
+      drift.define_singleton_method(:resolve_binary) { "/usr/local/bin/hive" }
+      result = drift.resolve
+      assert_equal true, result["drifted"], "a version mismatch must be flagged drifted"
+    end
+  end
+
+  def test_unresolvable_binary_is_unverified_not_false
+    drift = Hive::Daemon::Drift.new(pid: 4242, runner: FakeRunner.new)
+    drift.define_singleton_method(:resolve_binary) { nil }
+    result = drift.resolve
+    assert_equal false, result["verified"]
+    assert_nil result["drifted"], "an unresolvable binary must report unverified, never guess"
+    assert_equal "unverified", result["status"]
+  end
+
+  def test_linux_readlink_proc_exe_path
+    with_tmp_dir do |dir|
+      # Simulate /proc/<pid>/exe by pointing resolve_binary at a real file.
+      real = File.join(dir, "hive-real")
+      File.write(real, "#!/bin/sh\n")
+      FileUtils.chmod(0755, real)
+      drift = Hive::Daemon::Drift.new(pid: 4242, runner: FakeRunner.new(version: Hive::VERSION))
+      drift.define_singleton_method(:resolve_binary) { File.realpath(real) }
+      result = drift.resolve
+      assert_equal real, result["binary"]
+    end
+  end
+
+  def test_resolve_binary_picks_hive_script_not_ruby_interpreter
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "hive")
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0755, hive)
+      drift = Hive::Daemon::Drift.new(pid: 4242, runner: FakeRunner.new(version: Hive::VERSION))
+      # `hive daemon start` is `#!/usr/bin/env ruby`, so the live argv is the
+      # interpreter first, then the wrapper script. resolve_binary must return
+      # the script, never /usr/bin/ruby (which would false-positive as drift).
+      drift.define_singleton_method(:process_args) { [ "/usr/bin/ruby", hive, "daemon", "start" ] }
+      assert_equal File.realpath(hive), drift.send(:resolve_binary)
+    end
+  end
+
+  def test_resolve_binary_returns_nil_when_no_hive_script_in_argv
+    drift = Hive::Daemon::Drift.new(pid: 4242, runner: FakeRunner.new)
+    drift.define_singleton_method(:process_args) { [ "/usr/bin/ruby", "daemon", "start" ] }
+    assert_nil drift.send(:resolve_binary)
+  end
+
+  def test_resolve_binary_ps_command_fallback_resolves_script
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "hive")
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0755, hive)
+      drift = Hive::Daemon::Drift.new(
+        pid: 4_000_000_000, runner: FakeRunner.new(ps_out: "ruby #{hive} daemon start", version: Hive::VERSION)
+      )
+      assert_equal File.realpath(hive), drift.send(:resolve_binary)
+    end
+  end
+end
diff --git a/test/unit/commands/daemon_test.rb b/test/unit/commands/daemon_test.rb
index f87b788e0..adf9f6169 100644
--- a/test/unit/commands/daemon_test.rb
+++ b/test/unit/commands/daemon_test.rb
@@ -298,6 +298,74 @@ class HiveCommandsDaemonTest < Minitest::Test
   end
 
 
+  def test_status_json_includes_drift_fields
+    command = daemon("status", json: true)
+    write_pid_payload(pid: 1234)
+    command.define_singleton_method(:pid_alive?) { |pid| pid == 1234 }
+    command.define_singleton_method(:pid_owned_by_us?) { |_payload, pid| pid == 1234 }
+    command.define_singleton_method(:drift_payload) do |_pid|
+      { "binary" => "/usr/bin/hive", "version" => "0.1.0",
+        "current_binary" => "/usr/local/bin/hive", "current_version" => Hive::VERSION,
+        "verified" => true, "drifted" => true, "status" => "drifted" }
+    end
+
+    out, _err = capture_io { command.call }
+    doc = JSON.parse(out)
+    assert_equal "/usr/bin/hive", doc.fetch("daemon_binary")
+    assert_equal "0.1.0", doc.fetch("daemon_version")
+    assert_equal "drifted", doc.fetch("drift_status")
+    assert_equal true, doc.fetch("drifted")
+  end
+
+  # U5: `repair` re-runs install --force (rewriting the unit to the CLI
+  # binary) and emits the repair envelope.
+  def test_repair_json_rewrites_unit_and_emits_envelope
+    with_tmp_global_config_and_home do |dir|
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+      command = daemon("repair", json: true)
+      command.define_singleton_method(:current_binary_path) { hive }
+      out, _err = capture_io { command.call }
+      doc = JSON.parse(out)
+      assert_equal "hive-daemon-repair", doc.fetch("schema")
+      assert_equal true, doc.fetch("ok")
+      unit = File.join(dir, ".config/systemd/user/hive-daemon.service")
+      assert File.exist?(unit), "repair must rewrite the daemon unit"
+      assert_includes File.read(unit), "ExecStart=#{hive} daemon start"
+      assert_includes doc.fetch("target_path"), "hive-daemon.service"
+    end
+  end
+
+  # U5: `repair` must actually RESTART the drifted daemon, not just rewrite
+  # the unit file. `autostart: true` makes the installer restart the running
+  # service on the force-upgrade path.
+  def test_repair_reinstalls_with_autostart_and_force
+    calls = []
+    outcome = fake_outcome(:upgraded, restarted: true)
+    installer = FakeInstaller.new(target_path: "/tmp/fake-unit",
+                                  last_backup_path: nil,
+                                  last_restart_invoked: true,
+                                  envelope_platform: "linux",
+                                  messages: [])
+    installer.define_singleton_method(:install!) do |autostart:, force:|
+      calls << { autostart: autostart, force: force }
+      outcome
+    end
+    command = daemon("repair", json: true)
+    require "hive/commands/daemon/service_installer"
+    out, _err = with_replaced_singleton_method(
+      Hive::Commands::Daemon::ServiceInstaller, :new, ->(**_kwargs) { installer }
+    ) { capture_io { command.call } }
+
+    assert_equal [ { autostart: true, force: true } ], calls,
+                 "repair must reinstall with autostart so the drifted daemon is actually restarted"
+    doc = JSON.parse(out)
+    assert_equal true, doc.fetch("ok")
+    assert_equal true, doc.fetch("restarted")
+  end
+
   def test_status_json_includes_update_nudge_when_present
     with_env("HIVE_HOME" => @home) do
       Hive::UpdateCheck::State.new.set_nudge(latest: "9.9.9", channel: "brew",
diff --git a/test/unit/commands/setup/dependency_check_test.rb b/test/unit/commands/setup/dependency_check_test.rb
new file mode 100644
index 000000000..3ffe5f82e
--- /dev/null
+++ b/test/unit/commands/setup/dependency_check_test.rb
@@ -0,0 +1,204 @@
+require "test_helper"
+require "hive/commands/setup/dependency_check"
+
+class DependencyCheckTest < Minitest::Test
+  include HiveTestHelper
+
+  # A fake `which`: returns a path for installed tools, nil otherwise.
+  def fake_which(present:)
+    lambda do |name|
+      present.include?(name) ? "/usr/bin/#{name}" : nil
+    end
+  end
+
+  # A fake runner that records argv and scripts success/failure + stdout.
+  # Keys match the BINARY BASENAME (e.g. "ruby", "gh") regardless of the
+  # absolute path any given probe invokes. Defaults to a ruby 3.4 version
+  # string so "all present" scenarios pass the ruby version gate without
+  # every test re-injecting it.
+  class FakeRunner
+    attr_reader :calls
+
+    def initialize(ok: {}, out: {})
+      @ok = ok
+      @out = { "ruby" => "ruby 3.4.7 (2026-05-27) [x86_64-linux]\n" }.merge(out)
+      @calls = []
+    end
+
+    def call(argv)
+      @calls << argv
+      short = File.basename(argv.first)
+      two = argv[1] ? "#{short} #{argv[1]}" : short
+      success = @ok.key?(two) ? @ok[two] : @ok.fetch(short, true)
+      { success: success, out: @out.fetch(short, ""), err: "", status: nil }
+    end
+  end
+
+  ALL_PRESENT = %w[ruby git tmux gh claude codex node npm qmd sqlite3].freeze
+
+  def test_all_present_returns_ok
+    runner = FakeRunner.new
+    check = Hive::Commands::Setup::DependencyCheck.new(
+      which: fake_which(present: %w[ruby git tmux gh claude codex node npm qmd sqlite3]),
+      runner: runner
+    )
+    assert_equal Hive::Commands::Setup::DependencyCheck::EXIT_OK, check.call
+    assert check.rows.none? { |r| %w[missing version_too_old auth_missing bundle_failed broken].include?(r[:status]) }
+  end
+
+  def test_missing_gh_auth_emits_exact_fix_and_does_not_spawn_login
+    runner = FakeRunner.new(ok: { "gh" => false })
+    check = Hive::Commands::Setup::DependencyCheck.new(
+      which: fake_which(present: %w[ruby git tmux gh claude codex node npm qmd sqlite3]),
+      runner: runner
+    )
+    assert_equal Hive::Commands::Setup::DependencyCheck::EXIT_FIX_REQUIRED, check.call
+    gh = check.rows.find { |r| r[:name] == "gh" }
+    assert_equal "auth_missing", gh[:status]
+    assert_equal "gh auth login", gh[:fix_command]
+    # The login command was only reported as a fix, never executed.
+    refute_includes runner.calls, [ "gh", "auth", "login" ]
+  end
+
+  def test_broken_claude_and_codex_are_not_misreported_as_auth
+    runner = FakeRunner.new(ok: { "claude" => false, "codex" => false })
+    check = Hive::Commands::Setup::DependencyCheck.new(
+      which: fake_which(present: %w[ruby git tmux gh claude codex node npm qmd sqlite3]),
+      runner: runner
+    )
+    check.call
+    claude = check.rows.find { |r| r[:name] == "claude" }
+    codex = check.rows.find { |r| r[:name] == "codex" }
+    assert_equal "broken", claude[:status], "a failing --version is a broken install, not auth_missing"
+    assert_equal "broken", codex[:status]
+    assert_match(/reinstall Claude Code/, claude[:fix_command])
+    assert_match(/reinstall OpenAI Codex/, codex[:fix_command])
+  end
+
+  def test_missing_tool_reports_fix_command
+    check = Hive::Commands::Setup::DependencyCheck.new(
+      which: fake_which(present: %w[ruby]),
+      runner: FakeRunner.new
+    )
+    check.call
+    git = check.rows.find { |r| r[:name] == "git" }
+    assert_equal "missing", git[:status]
+    assert_match(/install git/, git[:fix_command])
+  end
+
+  def test_qmd_missing_is_hive_owned_with_install_command
+    check = Hive::Commands::Setup::DependencyCheck.new(
+      which: fake_which(present: %w[ruby git tmux gh claude codex node npm sqlite3]),
+      runner: FakeRunner.new,
+      data_home: "/tmp/hivedata"
+    )
+    check.call
+    qmd = check.rows.find { |r| r[:name] == "qmd" }
+    assert_equal "missing", qmd[:status]
+    assert qmd[:hive_owned]
+    assert_includes qmd[:fix_command], "@tobilu/qmd"
+    assert_includes qmd[:fix_command], "/tmp/hivedata/qmd"
+  end
+
+  def test_qmd_repair_attempted_only_when_npm_present
+    # npm present → qmd bootstrap is attempted.
+    runner = FakeRunner.new(ok: { "npm" => true })
+    check_with_npm = Hive::Commands::Setup::DependencyCheck.new(
+      which: fake_which(present: %w[ruby git tmux gh claude codex node npm sqlite3]),
+      runner: runner,
+      data_home: "/tmp/hivedata",
+      bootstrap: true
+    )
+    check_with_npm.call
+    assert check_with_npm.bootstrap_actions.any? { |b| b[:name] == "qmd" },
+           "qmd repair should be attempted when npm is present"
+    assert_includes runner.calls, [ "npm", "install", "--global", "--prefix", "/tmp/hivedata/qmd", "@tobilu/qmd" ]
+
+    # npm missing → qmd bootstrap is skipped (no spawn).
+    runner2 = FakeRunner.new
+    check_without_npm = Hive::Commands::Setup::DependencyCheck.new(
+      which: fake_which(present: %w[ruby git tmux gh claude codex node sqlite3]),
+      runner: runner2,
+      data_home: "/tmp/hivedata",
+      bootstrap: true
+    )
+    check_without_npm.call
+    skipped = check_without_npm.bootstrap_actions.find { |b| b[:name] == "qmd" }
+    assert_equal "skipped", skipped[:status]
+    refute runner2.calls.any? { |argv| argv.first == "npm" },
+           "qmd repair must not run when npm is absent"
+  end
+
+  def test_bundle_failed_reports_fix_and_bootstraps_only_for_app_dir
+    Dir.mktmpdir("hive-app") do |app_dir|
+      File.write(File.join(app_dir, "Gemfile"), "source 'https://rubygems.org'\n")
+
+      # Without bootstrap: bundle check fails → bundle_failed with exact fix.
+      runner = FakeRunner.new(ok: { "bundle check" => false })
+      check = Hive::Commands::Setup::DependencyCheck.new(
+        which: fake_which(present: ALL_PRESENT),
+        runner: runner,
+        app_dir: app_dir
+      )
+      check.call
+      bundle = check.rows.find { |r| r[:name] == "web bundle" }
+      assert_equal "bundle_failed", bundle[:status]
+      assert bundle[:hive_owned]
+      assert_includes bundle[:fix_command], "bundle install"
+
+      # With bootstrap: bundle install runs (Hive-owned app dir) and the row
+      # flips to present; the bootstrapped action is recorded.
+      runner2 = FakeRunner.new(ok: { "bundle check" => false })
+      check2 = Hive::Commands::Setup::DependencyCheck.new(
+        which: fake_which(present: ALL_PRESENT),
+        runner: runner2,
+        app_dir: app_dir,
+        bootstrap: true
+      )
+      check2.call
+      install = check2.bootstrap_actions.find { |b| b[:name] == "web bundle" }
+      assert_equal "installed", install[:status]
+      assert_equal "present", check2.rows.find { |r| r[:name] == "web bundle" }[:status]
+      assert runner2.calls.any? { |argv| argv == [ "bundle", "install", "--gemfile=#{File.join(app_dir, "Gemfile")}" ] },
+             "bundle bootstrap should be attempted for a Hive-owned app dir"
+    end
+  end
+
+  def test_no_app_dir_bundle_is_not_applicable
+    check = Hive::Commands::Setup::DependencyCheck.new(
+      which: fake_which(present: %w[ruby git tmux gh claude codex node npm qmd sqlite3]),
+      runner: FakeRunner.new,
+      app_dir: nil
+    )
+    check.call
+    bundle = check.rows.find { |r| r[:name] == "web bundle" }
+    assert_equal "not_applicable", bundle[:status]
+  end
+
+  def test_json_envelope_shape
+    out = StringIO.new
+    check = Hive::Commands::Setup::DependencyCheck.new(
+      json: true,
+      output: out,
+      which: fake_which(present: %w[ruby git tmux gh claude codex node npm qmd sqlite3]),
+      runner: FakeRunner.new
+    )
+    check.call
+    doc = JSON.parse(out.string)
+    assert_equal "hive-dependency-check", doc.fetch("schema")
+    assert_equal true, doc.fetch("ok")
+    assert doc.fetch("rows").all? { |r| r.key?("fix_command") && r.key?("hive_owned") }
+  end
+
+  def test_missing_external_cli_spawns_no_binary
+    # `which` returns nil for everything (bare minimal PATH) — the checker
+    # must not attempt to run any missing binary.
+    runner = FakeRunner.new
+    check = Hive::Commands::Setup::DependencyCheck.new(
+      which: ->(_name) { nil },
+      runner: runner
+    )
+    check.call
+    assert_empty runner.calls, "no external CLI may be spawned when nothing is on PATH"
+  end
+end
diff --git a/test/unit/commands/setup/setup_test.rb b/test/unit/commands/setup/setup_test.rb
new file mode 100644
index 000000000..865544c38
--- /dev/null
+++ b/test/unit/commands/setup/setup_test.rb
@@ -0,0 +1,179 @@
+require "test_helper"
+require "hive/commands/setup"
+require "hive/commands/setup/backend_prompt"
+require "hive/commands/setup/dependency_check"
+require "hive/commands/service_installer/outcome"
+
+class SetupTest < Minitest::Test
+  include HiveTestHelper
+
+  # A fake backend prompt: returns a fixed selection, or raises Aborted.
+  class FakeBackendPrompt
+    def initialize(selection, abort: false)
+      @selection = selection
+      @abort = abort
+    end
+
+    def collect
+      raise Hive::Commands::Setup::BackendPrompt::Aborted, "EOF" if @abort
+
+      @selection
+    end
+  end
+
+  class FakeDependencyCheck
+    def initialize(rows, ok:, code:)
+      @rows = rows
+      @ok = ok
+      @code = code
+    end
+
+    attr_reader :rows
+
+    def call
+      @code
+    end
+
+    def bootstrap_actions
+      []
+    end
+  end
+
+  class FakeInstaller
+    def initialize(outcome)
+      @outcome = outcome
+    end
+
+    def install!(autostart:, force:)
+      @outcome
+    end
+
+    def target_path
+      "/tmp/fake-unit"
+    end
+  end
+
+  def setup
+    @home = Dir.mktmpdir("hive-setup")
+    File.write(File.join(@home, "config.yml"), { "registered_projects" => [] }.to_yaml)
+  end
+
+  def teardown
+    FileUtils.rm_rf(@home) if @home
+  end
+
+  def with_home
+    with_env("HIVE_HOME" => @home) { yield }
+  end
+
+  def ok_rows
+    %w[ruby git tmux gh claude codex node npm qmd sqlite3].map do |name|
+      { name: name, status: "present", detail: "#{name} present", fix_command: nil, hive_owned: false }
+    end + [ { name: "web bundle", status: "not_applicable", detail: "no app dir", fix_command: nil, hive_owned: true } ]
+  end
+
+  def build(json: true, backend: nil, deps: nil, daemon: nil, web: nil, health: nil, non_interactive: false)
+    Hive::Commands::Setup.new(
+      json: json,
+      non_interactive: non_interactive,
+      output: StringIO.new,
+      input: StringIO.new,
+      backend_prompt: backend,
+      dependency_check: deps,
+      daemon_installer: daemon,
+      web_installer: web,
+      health: health
+    )
+  end
+
+  def test_full_flow_reaches_health_and_emits_envelope
+    with_home do
+      out = StringIO.new
+      setup = Hive::Commands::Setup.new(
+        json: true, output: out, input: StringIO.new, non_interactive: true,
+        backend_prompt: FakeBackendPrompt.new(%w[claude codex]),
+        dependency_check: FakeDependencyCheck.new(ok_rows, ok: true, code: 0),
+        daemon_installer: FakeInstaller.new(Hive::Commands::ServiceInstaller::Outcome.new(:written)),
+        web_installer: FakeInstaller.new(Hive::Commands::ServiceInstaller::Outcome.new(:written)),
+        health: ->(_url) { { ok: true, status: 200, body: { "ok" => true } } }
+      )
+      assert_equal Hive::Commands::Setup::EXIT_OK, setup.call
+      doc = JSON.parse(out.string)
+      assert_equal "hive-setup", doc.fetch("schema")
+      assert_equal true, doc.fetch("ok")
+      names = doc.fetch("steps").map { |s| s["name"] }
+      assert_includes names, "dependencies"
+      assert_includes names, "daemon"
+      assert_includes names, "web"
+      assert_includes names, "health"
+      health = doc.fetch("steps").find { |s| s["name"] == "health" }
+      assert_equal "ok", health["status"]
+      assert_equal 200, doc.dig("health", "status")
+    end
+  end
+
+  def test_missing_external_dep_reports_fix_required_nonzero
+    with_home do
+      rows = ok_rows.map { |r| r[:name] == "gh" ? r.merge(status: "auth_missing", fix_command: "gh auth login") : r }
+      dep = FakeDependencyCheck.new(rows, ok: false, code: 65)
+      out = StringIO.new
+      setup = Hive::Commands::Setup.new(
+        json: true, output: out, input: StringIO.new, non_interactive: true,
+        backend_prompt: FakeBackendPrompt.new(%w[claude]),
+        dependency_check: dep,
+        daemon_installer: FakeInstaller.new(Hive::Commands::ServiceInstaller::Outcome.new(:written)),
+        web_installer: FakeInstaller.new(Hive::Commands::ServiceInstaller::Outcome.new(:written)),
+        health: ->(_url) { { ok: true, status: 200, body: {} } }
+      )
+      assert_equal Hive::Commands::Setup::EXIT_FIX_REQUIRED, setup.call
+      doc = JSON.parse(out.string)
+      assert_equal false, doc.fetch("ok")
+      assert_equal 65, doc.fetch("exit_code")
+      deps_step = doc.fetch("steps").find { |s| s["name"] == "dependencies" }
+      assert_equal "fix_required", deps_step["status"]
+      gh_row = doc.dig("dependencies", "rows").find { |r| r["name"] == "gh" }
+      assert_equal "gh auth login", gh_row["fix_command"]
+    end
+  end
+
+  def test_non_interactive_persists_default_backends_without_prompting
+    with_home do
+      # non_interactive: true → defaults are used; the injected prompt.collect
+      # is never called (use an aborting prompt to prove it isn't touched).
+      out = StringIO.new
+      setup = Hive::Commands::Setup.new(
+        json: true, output: out, input: StringIO.new, non_interactive: true,
+        backend_prompt: FakeBackendPrompt.new(%w[claude codex], abort: true),
+        dependency_check: FakeDependencyCheck.new(ok_rows, ok: true, code: 0),
+        daemon_installer: FakeInstaller.new(Hive::Commands::ServiceInstaller::Outcome.new(:written)),
+        web_installer: FakeInstaller.new(Hive::Commands::ServiceInstaller::Outcome.new(:written)),
+        health: ->(_url) { { ok: true, status: 200, body: {} } }
+      )
+      setup.call
+      doc = JSON.parse(out.string)
+      # defaults persisted (claude + codex), aborted prompt not consulted.
+      assert_includes doc.fetch("backend_selection"), "claude"
+      assert_includes doc.fetch("backend_selection"), "codex"
+      assert_equal true, doc.fetch("ok")
+    end
+  end
+
+  def test_daemon_drift_is_reported_and_flips_ok
+    with_home do
+      out = StringIO.new
+      setup = Hive::Commands::Setup.new(
+        json: true, output: out, input: StringIO.new, non_interactive: true,
+        backend_prompt: FakeBackendPrompt.new(%w[claude]),
+        dependency_check: FakeDependencyCheck.new(ok_rows, ok: true, code: 0),
+        daemon_installer: FakeInstaller.new(Hive::Commands::ServiceInstaller::Outcome.new(:drifted)),
+        web_installer: FakeInstaller.new(Hive::Commands::ServiceInstaller::Outcome.new(:written)),
+        health: ->(_url) { { ok: true, status: 200, body: {} } }
+      )
+      assert_equal Hive::Commands::Setup::EXIT_FIX_REQUIRED, setup.call
+      doc = JSON.parse(out.string)
+      daemon_step = doc.fetch("steps").find { |s| s["name"] == "daemon" }
+      assert_equal "drifted", daemon_step["status"]
+      assert_match(/install --force/, daemon_step["detail"])
+    end
+  end
+end
